function handles = filter_data(handles)
%filters data, data should be initialized beforehand.

% setting up coefficients... 
% channel 2 has a lower sampling rate so...
if (handles.numChannels == 1)
    [b a] = butter(5,0.2,'high');
elseif(handles.numChannels == 2)
    [b a] = butter(5,0.4,'high');
end

handles.datahp = handles.data;
handles.datahp(1:5) = 0; %initializing high pass data field

%loop used to high pass filter.
for n = 6:max(size(handles.data()))
    if (handles.numChannels == 1)
        handles.datahp(n) = dot(b(1:6),handles.data(n:-1:(n-5))) - dot(a(2:6),handles.datahp((n-1):-1:(n-5)));
    else
        handles.datahp(1,n) = dot(b(1:6),handles.data(1,n:-1:(n-5))) - dot(a(2:6),handles.datahp(1,(n-1):-1:(n-5)));
        handles.datahp(2,n) = dot(b(1:6),handles.data(2,n:-1:(n-5))) - dot(a(2:6),handles.datahp(2,(n-1):-1:(n-5)));
    end
end

%rectification
handles.datarect = abs(handles.datahp);

%timeaveraging set by variable avgnum
handles.datatimeavg = handles.datarect;
for n = (handles.avgnum+1):(max(size(handles.data))-handles.avgnum)
    handles.datatimeavg(:,n) = mean( handles.datarect(:,(n-handles.avgnum):n),2);
end